##parameters=actions={}, current_action=None, docinfo={}

# actions must be from listFilteredActionsFor(here)
# current_action is the current action, skipped in the box
# docinfo is the current docinfo from cpsdocument_info_get

# Actually not only used for documents, also for folders

here = context.this()
roles = context.portal_membership.getAuthenticatedMember().getRolesInContext(here)

mcat = context.portal_messages

folderishtrans = "_folderish_actions"
unversionnedtrans = "_unversionned_actions"

here = context.this()

# docinfo = context.cpsdocument_info_get(item=here)

rs = docinfo['review_state']
vs = docinfo['version_state']
ss = docinfo['schema_state']

rstitle = mcat('_reviewstate_%s' % (rs, ))
vstitle = mcat('_versionstate_%s' % (vs, ))

if vs in ('stable', 'initial', None) and rs is not None:
    # rstitle = rstitle
    pass
elif vs == 'locked':
    rstitle = "%s (%s)" % (rstitle, vstitle)
elif vs in ('draft', 'archive'):
    rstitle = vstitle
else:
    if docinfo['folderish']:
        rstitle = mcat(folderishtrans)
    else:
        #rstitle = '??? [vs=%s]' % vs
        rstitle = mcat(unversionnedtrans)

#
# Filter actions into blocks, and remove the current one.
#

actionsblocks = []
for category in ('schema', 'workflow', 'publication', 'object', 'version', 'folder'):
    block = actions.get(category, [])
    if current_action is not None:
        okblock = []
        for action in block:
            if action.get('id', None) != current_action:
                okblock.append(action)
        block = okblock
    if block:
        actionsblocks.append(block)

#
# Add actionsbox help (if actionsbox is there).
#

if actionsblocks:
    helpurl = 'help?where=actionsbox&current_action='+str(current_action)
    helpblock = [{'id': 'help',
                  'url': helpurl,
                  'onclick': "return popupHelp('%s')" % helpurl,
                  'target': 'help',
                  'name': '_action_help_',
                  }]
    actionsblocks.append(helpblock)

#
# Add info blocks (XXX currently unused)
#

infoblocks = []

#
# Return that
#

d = {
    'docinfo': docinfo,
    'rstitle': rstitle,
    'actionsblocks': actionsblocks,
    'infoblocks': infoblocks,
}

return d
