##parameters=role, opener_form, opener_select, currentids=[], search_submit=None, search_field=None, search_string=None, selected_dir='members', REQUEST=None, **kw

mcat = context.portal_messages
dialogtitle = mcat(role) # XXX Translate
dirtool = context.portal_metadirectories

# Go through each directory in the metadirectories tool, and make a dict of
# lists of dicts with the possible fields to search in for each directory.
# We need both a python version for use by ZPT, as a Javascrivpt version for
# use by Javascript. The Javascript version is made by assembling together a
# string that contains the source code for creating a dictionary of lists of
# dictionaries for Javascript. Unfortunately, Javascript do not have quotes
# around the keys like python does, otherwise 'repr' would have worked.
dirs = []
dirs_fields = {}
js_dirs_fields = '{'

for directory in dirtool.objectValues():
    dirs.append( {'id': directory.getId(), 'title': directory.title_or_id()})
    searchable_fields = []
    js_searchable_fields = []
    schema = directory.getSchemaDict()
    for field in directory.getSearchableSchemaKeys():
        property = schema[field]
        searchable_fields.append({'value': property.id, 'text': property.title})
        js_searchable_fields.append('{value: "%s", text: "%s"}' % \
            (property.id, property.title))
    dirs_fields[directory.getId()] = searchable_fields
    js_searchable_fields = '[%s]' % ', '.join(js_searchable_fields)
    js_dirs_fields += "%s: %s," % (directory.getId(), js_searchable_fields)
js_dirs_fields += '}'


# If these exist, a search button has been pushed.
# Do a search and put it into the search_results variable.
search_results = []
if search_submit and search_field:
    directory = dirtool[selected_dir]
    kw={search_field: search_string}
    results = directory.searchEntry(**kw)

    if selected_dir=='groups':
        prefix = 'group:'
        title = '[%s]'
    else:
        prefix = ''
        title = '%s'
    for entry in results:
        search_results.append(  {'id': prefix + entry[directory.entry_prop], \
                                'title': title % entry[directory.display_prop]})

current_users = []
for each in currentids:
    if each[:len('group:')] == 'group:':
        directory = dirtool.groups
        id = each[len('group:'):]
        title = '[%s]'
    elif each[:len('_group_')] == '_group_':
        directory = dirtool.groups
        id = each[len('_group_'):]
        title = '[%s]'
    else:
        directory = dirtool.members
        id = each
        title = '%s'
    entry = directory.getEntry(id)
    if entry:
        title = title % entry[directory.display_prop]
    else:
        title = title % id
    current_users.append({'id': each, 'title': title})

data = {
    'hasjs': 1,
    'title': dialogtitle,
    'nogroups': 0,
    'role': role,
    'directories': dirs,
    'searchable_fields': dirs_fields,
    'js_search_fields': js_dirs_fields,
    'selected_dir': selected_dir,
    'search_field': 'id_',
    'current': current_users,
    'search_results': search_results,
    'opener_form': opener_form,
    'opener_select': opener_select,
    }


return context.localrole_popup_form(data=data)
