##parameters=REQUEST=None

# This gets a data structure describing the contents
# to display for the current reviewed hierarchy level

import zLOG
 
def log(message,summary='',severity=0):
    zLOG.LOG('hierarchy[%s]'%context.getId(),severity,summary,message + '\n')

here = context.this()

mcat = context.portal_messages
hereurl = here.absolute_url(relative=1)
if hereurl: hereurl = '/'+hereurl
portal_url = context.portal_url(relative=1)
if portal_url: portal_url = '/'+portal_url
mtool = context.portal_membership
user = mtool.getAuthenticatedMember()
roles = user.getRoles()

readers = here.LevelReaders()
if readers and not 'Manager' in roles:
    readers = readers + here.LevelReviewers()

    myid = user.getUserName()
    try: mygroups = user.getGroups()
    except: mygroups = ()
    myids = [myid] + ['group:'+id for id in mygroups]

    ok = 0
    for id in myids:
        if id in readers:
            ok = 1
            break
    if not ok:
        return {'pubinfos':[], 'pendinfos':[]} # not authorized to see this level

rubinfos = []
children = here.getChildrenValues()
# children = here.objectValues()
for item in children:
    if not mtool.checkPermission('View', item):
        continue
    try:
        d = context.cpsdocument_info_get(item=item, mcat=mcat)
        if item.portal_type == "Forum":
            d['icon'] = '%s/forum_icon.gif' % portal_url
        else:
            d['icon'] = '%s/folder_icon.gif' % portal_url
    except: # XXX child is unauthorized (restricted subcategory)
        continue
    d['action'] = 'view'
    d['moddate'] = ''
    d['modification'] = ''
    d['nocheck'] = 1
    rubinfos.append(d)


exclude_meta_types = ()

pubinfos = []
documents = here.queryCatalog()
for brain in documents:
    if brain.meta_type in exclude_meta_types:
        continue
    d = context.cpsdocument_info_get(brain=brain, mcat=mcat)
    d['url'] = hereurl+'/'+d['id']
    d['nocheck'] = 1
    pubinfos.append(d)


pendinfos = []
if here.publicationAllowedForUser():
    documents = here.queryPendingCatalog()
    for brain in documents:
        if brain.meta_type in exclude_meta_types:
            continue
        d = context.cpsdocument_info_get(brain=brain, mcat=mcat)
        d['url'] = hereurl+'/'+d['id']
        d['nocheck'] = 1
        pendinfos.append(d)

pubinfos.sort(lambda x,y: x['moddate']<y['moddate'] or -1)
pendinfos.sort(lambda x,y: x['moddate']<y['moddate'] or -1)

return {
    'pubinfos': rubinfos + pubinfos,
    'pendinfos': pendinfos,
    }
