#
# (C) Copyright 2002 Nuxeo SARL <http://www.nuxeo.com/>
# This product is governed by a license. See LICENSE.txt file.
#

# Python
import sys

# This product
import Forum, Post, ThreadSnapShot, ForumNotificationTool

# CMF
from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore.CMFCorePermissions import AddPortalContent

contentClasses = ( Forum.Forum
                 , Post.Post
                 , ThreadSnapShot.ThreadSnapShot
                 )

contentConstructors = ( Forum.addForum
                      , Post.addPost
                      , ThreadSnapShot.add_snapshot
                      )

fti = ( Forum.factory_type_information
        + Post.factory_type_information
        + ThreadSnapShot.factory_type_information
        )

registerDirectory('skins', globals())

this_module = sys.modules[__name__]
tools = (ForumNotificationTool.ForumNotificationTool, )
z_tool_bases = utils.initializeBasesPhase1(tools, this_module)

def initialize(registrar):
    #
    # Register the Forum, Post and  ThreadSnapShot classes
    #
    utils.ToolInit('Forum Notification Tool',
        tools=tools,
        product_name='NuxCPSForum',
        icon='tool.gif'
    ).initialize(registrar)
      
    utils.ContentInit('CPS Forum Content', 
        content_types=contentClasses, 
        permission=AddPortalContent, 
        extra_constructors=contentConstructors, 
        fti=fti
    ).initialize(registrar)

