##############################################################################
#
# Copyright (c) 2001 Zope Corporation and Contributors. All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

from Interface import Base

class IPost(Base):
    def thread_top():
        """Return the top ancestor"""

    def ancestors():
        """Return a list of ancestral posts"""

    def descendants():
        """Return a list of descendant posts"""

    def children(sort_key='id', REQUEST=None):
        """Return a list of replies to this item"""

    def inReplyTo():
        """Return the object for which this object is a reply"""

    def nextReply():
        """Return the next object that is reply"""

    def nextMessage():
        """Return the next object on the same level"""

    def previousMessage():
        """Return the previous object on the same level"""

    def inReplyTo():
        """Return the id of the object for which this object is a reply"""

    def childMessageCount():
        """Count the number of chilren of this message, including this message"""
    def threadMessageCount():
        """Look at the topmost ancestor, and then count children"""
        
    def childNewestMessageDate():
        """Look through children and returns the newest message date"""

    def threadNewestMessageDate():
        """Look at the topmost ancestor, and then recurse
        through the messages finding the last created message
        """

    def hasAttachments():
        """Boolean value to test if the message has any attachment"""

    def getAttachments():
        """Return a list of attachment objects"""

    def addPost(id='', title='', text='', author='', email='', file=None,
      REQUEST=None):
        """Add a Post to its container"""

    def isSubscribed():
        """Return user subscription state"""

    def subscribe():
        """Subscribe user to Post"""

    def unsubscribe():
        """Remove user subscription to Post"""

