# Copyright (c) 2002 Nuxeo SARL <http://nuxeo.com>
# Copyright (c) 2002 Prfecture du Bas-Rhin, France
# Author: Florent Guillaume <mailto:fg@nuxeo.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: __init__.py,v 1.7 2003/04/06 09:42:38 fermigier Exp $

import sys

from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory

import HierarchiesTool
import BaseHierarchyLevel
import SimpleHierarchy, SimpleHierarchyLevel
import ReviewedHierarchy, ReviewedHierarchyLevel


contentClasses = (SimpleHierarchyLevel.SimpleHierarchyLevel,
                  ReviewedHierarchyLevel.ReviewedHierarchyLevel,
                  )
contentConstructors = (SimpleHierarchyLevel.addSimpleHierarchyLevel,
                       ReviewedHierarchyLevel.addReviewedHierarchyLevel,
                       )
fti = (SimpleHierarchyLevel.factory_type_information +
       ReviewedHierarchyLevel.factory_type_information
       )
bases = contentClasses

tools = (HierarchiesTool.HierarchiesTool,)

this_module = sys.modules[__name__]
z_bases = utils.initializeBasesPhase1(bases, this_module)
z_tool_bases = utils.initializeBasesPhase1(tools, this_module)

registerDirectory('skins', globals())

def initialize(registrar):
    utils.initializeBasesPhase2(z_bases, registrar)
    utils.initializeBasesPhase2(z_tool_bases, registrar)
    utils.ToolInit(
        'CMF NuxHierarchies Tool',
        tools = tools,
        product_name = 'NuxHierarchies', # for icon and ?...
        icon = 'tool.gif',
        ).initialize(registrar)
    utils.ContentInit(
        'CMF NuxHierarchies Level',
        content_types = contentClasses,
        permission = HierarchiesTool.AddHierarchyLevel,
        extra_constructors = contentConstructors,
        fti = fti,
        ).initialize(registrar)
    # icon for hierarchies in the tool
    utils.registerIcon(SimpleHierarchy.SimpleHierarchy, 'hierarchy.gif',
                       globals())
    utils.registerIcon(ReviewedHierarchy.ReviewedHierarchy, 'hierarchy.gif',
                       globals())

