# Copyright (c) 2002 Nuxeo SARL <http://nuxeo.com>
# Copyright (c) 2002 Prfecture du Bas-Rhin, France
# Copyright (c) 2002 CIRB, Belgique
# Authors: Florent Guillaume <mailto:fg@nuxeo.com>
#          Julien Jalon <mailto:jj@nuxeo.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: __init__.py,v 1.7 2003/04/06 09:55:52 fermigier Exp $

import sys
from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore.CMFCorePermissions import AddPortalContent
from AccessControl.Permission import registerPermissions

import PortalBoxesTool
import BaseBox
import TextBox
import DocFilterBox
import WGNavBox
import CatNavBox

# registerPermissions(('Box Minimize', 'Box Close', 'Box Change Style', 'Box Change Pos'), defaultDefault=('Manager', 'Owner', 'Anonymous'))

boxClasses = (BaseBox.BaseBox,
              TextBox.TextBox,
              DocFilterBox.DocFilterBox,
              WGNavBox.WGNavBox,
              CatNavBox.CatNavBox,
              )

contentConstructors = (BaseBox.addBaseBox,
                       TextBox.addTextBox,
                       DocFilterBox.addDocFilterBox,
                       WGNavBox.addWGNavBox,
                       CatNavBox.addCatNavBox,
                       )
fti = (BaseBox.factory_type_information +
       TextBox.factory_type_information +
       DocFilterBox.factory_type_information +
       WGNavBox.factory_type_information +
       CatNavBox.factory_type_information +
       ())
bases = boxClasses

tools = (PortalBoxesTool.PortalBoxesTool,
         )

this_module = sys.modules[__name__]
z_bases = utils.initializeBasesPhase1(bases, this_module)
z_tool_bases = utils.initializeBasesPhase1(tools, this_module)

registerDirectory('skins', globals())

def initialize(registrar):
    utils.initializeBasesPhase2(z_bases, registrar)
    utils.initializeBasesPhase2(z_tool_bases, registrar)
    utils.ToolInit(
        'CMF NuxPortal Boxes Tool',
        tools = tools,
        product_name = 'NuxPortal', # for icon and ?...
        icon = 'tool.gif',
        ).initialize(registrar)
    utils.ContentInit(
        'CMF NuxPortal Boxes',
        content_types = boxClasses,
        permission = AddPortalContent,
        extra_constructors = contentConstructors,
        fti = fti,
        ).initialize(registrar)
    # icons
    for klass in boxClasses:
        utils.registerIcon(klass, 'box.gif', globals())

