##parameters=state={}, **kw

import string

here = context.this()
request = context.REQUEST
bc = request.other['breadcrumbs']
here_url = bc[-1]['url']

portal_path_length = len(context.portal_url.getPortalPath())
portal_url = context.portal_url(relative=1)
if portal_url: 
    portal_url = '/' + portal_url

in_some_group = 0
paths = here.getProperty('paths', []) # actually rurls
maxdepth = here.getProperty('depth', 0)
if maxdepth <= 0:
    maxdepth = 999

mtool = None
dirtool = None
mcat = None
wgroups = context.portal_catalog.searchResults(meta_type='Workgroup')
groups = []
mindepth = 999
for brain in wgroups:
    path = brain.getPath() # physical
    rurl = path[portal_path_length:] # /relative to portal
    # is this path under one of the specified paths
    if paths:
        bestdepth = 1900
        for root in paths:
            if root.startswith('~'):
                if mtool is None:
                    mtool = here.portal_membership
                    home_root = '/Members/' \
                      + mtool.getAuthenticatedMember().getUserName()
                root = home_root + root[1:]
            l = len(root)
            if rurl[:l] == root: # same prefix
                depth = string.count(rurl[l:], '/')
                if bestdepth > depth:
                    bestdepth = depth
        depth = bestdepth
    else:
        depth = string.count(rurl, '/')
    title = brain.Title or brain.id
    url = portal_url + rurl
    d = {
        'title': title,
        'depth': depth,
        'url': url,
        'id': brain.id,
    }
    if here_url.startswith(url+'/'):
        in_some_group = 1
        d['in'] = 1
    if getattr(brain, 'isTitleDynamic', 0):
        d['title_is_dynamic'] = 1
    groups.append(d)
    if mindepth > depth:
        mindepth = depth

okgroups = []
for d in groups:
    depth = d['depth'] - mindepth
    if depth < maxdepth:
        d['depth'] = depth
        okgroups.append(d)

if in_some_group:
    def cmpgroups(a, b):
      return cmp(b['url'], a['url'])

    okgroups.sort(cmpgroups)

    in_group = 0

    for group in okgroups:
        if group.get('in'):
            if in_group:
                del group['in']
            else:
                in_group = 1

    okgroups.reverse()
else:
    def cmpgroups(a, b):
      return cmp(a['url'], b['url'])

    okgroups.sort(cmpgroups)

# Now replace dynamic titles.
for d in okgroups:
    if d.get('title_is_dynamic'):
        id = d['id']
        if dirtool is None:
            dirtool = context.portal_metadirectories.members
        if mcat is None:
            mcat = context.portal_messages
        entry = dirtool.getEntry(id)
        if entry is None:
            fullname = id
        else:
            fullname = entry.get(dirtool.display_prop, id)
        title = mcat('_private_area_of_%s_') % (fullname, )
        d['title'] = title

return context.navbox_render_body(groups=okgroups)
