##parameters=REQUEST=None

here = context.this()
portal_url = context.portal_url()
mtool = context.portal_membership
dirtool = context.portal_metadirectories
dtool = dirtool.members
gdtool = dirtool.groups
dtool_entry_url = "%s/%s?dirname=%s&entry_id=" % (portal_url, dtool.entry_template, dtool.id)
gdtool_entry_url = "%s/%s?dirname=%s&entry_id=" % (portal_url, gdtool.entry_template, gdtool.id)

lroles = here.get_local_roles()
try: lgroups = here.get_local_group_roles()
except: lgroups = ()
try: allgroups = here.get_valid_groupids()
except: allgroups = ()

m = mtool.getAuthenticatedMember()

owners = []
members = []
visitors = []
fullnames = {}
dir_urls = {}
for id, r in lroles:
    if 'WorkgroupManager' in r:
        owners.append(id)
    elif 'WorkgroupMember' in r:
        members.append(id)
    elif 'WorkgroupVisitor' in r:
        visitors.append(id)

for id, r in lgroups:
    gid = '_group_%s' % id
    if gdtool:
        entry = gdtool.getEntry(id)
    else:
        entry = None
    if entry:
        fullname = '[%s]' % ([gdtool.display_prop] or gid)
        url = gdtool_entry_url + id
    else:
        fullname = '[%s]' % gid
        url = None
    fullnames[gid] = fullname
    dir_urls[gid] = url

    if 'WorkgroupManager' in r:
        owners.append(gid)
    elif 'WorkgroupMember' in r:
        members.append(gid)
    elif 'WorkgroupVisitor' in r:
        visitors.append(gid)

iscontent = getattr(here, 'isPortalContent', 0)
croles = mtool.getCandidateLocalRoles(here);
keeproles = ['WorkgroupManager', 'WorkgroupVisitor']
if not iscontent:
    keeproles.append('WorkgroupMember')
roles = [r for r in croles if r in keeproles]
trans = {
    'WorkgroupManager': iscontent and '_workgroup_Owner_' or '_workgroup_Manager_',
    'WorkgroupMember': '_workgroup_Member_',
    'WorkgroupVisitor': '_workgroup_Visitor_'
}

for id in owners+members+visitors:
    if fullnames.has_key(id):
        continue
    entry = dtool.getEntry(id)
    if entry:
        fullnames[id] = entry[dtool.display_prop] or id
        dir_urls[id] = dtool_entry_url + id
    else:
        fullnames[id] = id

return {
    'owners': owners,
    'members': members,
    'visitors': visitors,
    'roles': roles,
    'trans': trans,
    'allgroups': allgroups,
    'fullnames': fullnames,
    'dir_urls': dir_urls
}

